#include <algorithm>
#include <iostream>
#include <fstream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 2e9;

inline std::string convertNum(int num)
{
    std::string res;
    int base = 1000;
    for (int i = 0 ; i < 4 ; ++i)
    {
        char c = '0';
        c += (num / base) % 10;
        res += c;
        base /= 10;
    }

    return "test." + res + ".in";
}

int perm[MAXN];
int main()
{
    std::ofstream file;
    std::ios_base :: sync_with_stdio(0);
    file.tie(nullptr);
    srand(time(nullptr));
    for (int i = 1 ; i <= 1000 ; ++i)
    {
        int n = 2000;
        file.open(convertNum(i));
        std::iota(perm + 1, perm + 1 + n, 1);
        std::random_shuffle(perm + 1, perm + 1 + n);
        file << n << '\n';
        for (int j = 1 ; j <= n ; ++j) file << rand()%(int)1e6 + 1 << ' '; file << '\n';
        for (int j = 1 ; j <= n ; ++j) file << rand()%(int)n + 1 << ' '; file << '\n';
        for (int j = 2 ; j <= n ; ++j)
        {
            file << perm[rand()%(j - 1) + 1] << ' ' << perm[j] << '\n';
        }

        file.close();
    }
    return 0;
}