#include <algorithm>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

typedef long long llong;
const int MAXN = 2000;

int n;
int l[MAXN];
int c[MAXN];
int u[MAXN];
int v[MAXN];

int main(int argc , char **argv)
{
    std::ifstream fin;
    std::ofstream fout;
    fin.open(argv[1]);

    fin >> n;
    for (int i = 1 ; i <= n ; ++i) fin >> c[i];
    for (int i = 1 ; i <= n ; ++i) fin >> l[i];
    for (int i = 1 ; i <= n - 1 ; ++i)
    {
        fin >> u[i] >> v[i];
    }

    int max = 1;
    for (int i = 1 ; i <= n ; ++i) max = std::max(max, c[i]);
    for (int i = 1 ; i <= n ; ++i) c[i] *= 1000000 / max;
    fin.close();
    fout.open(argv[1]);
    fout << n << '\n';
    for (int i = 1 ; i <= n ; ++i)
    {
        fout << c[i];
        if (i != n) fout << ' ';
    }
    fout << '\n';

    for (int i = 1 ; i <= n ; ++i)
    {
        fout << l[i];
        if (i != n) fout << ' ';
    }
    fout << '\n';

    for (int i = 1 ; i <= n ; ++i)
    {
        fout << u[i] << ' ' << v[i] << '\n';
    }

    return 0;
}